Index: /EcnlProtoTool/trunk/asp3_dcre/Debug/Makefile
===================================================================
--- /EcnlProtoTool/trunk/asp3_dcre/Debug/Makefile	(revision 440)
+++ /EcnlProtoTool/trunk/asp3_dcre/Debug/Makefile	(revision 441)
@@ -246,12 +246,4 @@
 #  システムサービスに関する定義
 #
-ifdef TCINSTALL
-GCC_PATH = $(TCINSTALL)
-else
-GCC_PATH = $(shell which $(CC))/../../
-endif
-MALLOC_LIB = "${GCC_PATH}arm-none-eabi/lib/thumb/v7-ar/fpv3/hard/libc.a"
-MALLOC_OBJS = lib_a-reent.o lib_a-impure.o lib_a-malloc.o lib_a-mallocr.o lib_a-calloc.o lib_a-callocr.o lib_a-realloc.o lib_a-reallocr.o lib_a-sbrkr.o lib_a-freer.o
-
 SYSSVC_DIRS := $(TECSGENDIR) $(SRCDIR)/tecs_kernel \
 				$(SYSSVC_DIRS) $(SRCDIR)/syssvc
@@ -380,5 +372,4 @@
 CFG_COBJS      := $(addprefix $(OBJDIR)/, $(CFG_COBJS))
 CFG_DMY        := $(addprefix $(OBJDIR)/, $(CFG_DMY))
-MALLOC_OBJS    := $(addprefix $(OBJDIR)/, $(MALLOC_OBJS))
 
 #
@@ -387,5 +378,5 @@
 APPL_OBJS = $(APPL_ASMOBJS) $(APPL_COBJS) $(APPL_CXXOBJS)
 SYSSVC_OBJS = $(SYSSVC_ASMOBJS) $(SYSSVC_COBJS) $(HIDDEN_OBJS)
-KERNEL_LIB_OBJS = $(KERNEL_ASMOBJS) $(KERNEL_COBJS) $(KERNEL_LCOBJS) $(MALLOC_OBJS)
+KERNEL_LIB_OBJS = $(KERNEL_ASMOBJS) $(KERNEL_COBJS) $(KERNEL_LCOBJS)
 CFG_OBJS = $(CFG_ASMOBJS) $(CFG_COBJS)
 ALL_OBJS = $(START_OBJS) $(APPL_OBJS) $(SYSSVC_OBJS) $(CFG_OBJS) \
@@ -554,5 +545,4 @@
 	rm -f libsyssvc.a
 endif
-	rm -f $(MALLOC_OBJS)
 
 .PHONY: cleankernel
@@ -678,8 +668,4 @@
 	$(CC) -c -o $@ -MD -MP -MF $(DEPDIR)/$*.d $(CFLAGS) $(APPL_CFLAGS) $<
 
-$(MALLOC_OBJS): $(OBJDIR)/%.o:
-	$(AR) x $(MALLOC_LIB) $(notdir $@)
-	mv $(notdir $@) $@
-
 #
 #  デフォルトコンパイルルールを上書き
Index: /EcnlProtoTool/trunk/ntshell/Debug/Makefile
===================================================================
--- /EcnlProtoTool/trunk/ntshell/Debug/Makefile	(revision 440)
+++ /EcnlProtoTool/trunk/ntshell/Debug/Makefile	(revision 441)
@@ -199,5 +199,5 @@
 	CDEFS := -DTOPPERS_OMIT_TECS $(CDEFS)
 endif
-CDEFS := $(CDEFS) -DFD_SETSIZE=32
+CDEFS := $(CDEFS) -DFD_SETSIZE=32 -DDHCP4_CLI_CFG -DUSE_PING -DUSE_RESOLVER -DUSE_NETAPP_SUBR
 INCLUDES := -I. -I$(SRCDIR)/include $(INCLUDES) -I$(SRCDIR)
 LDFLAGS := $(LDFLAGS) -L.
@@ -213,11 +213,11 @@
 APPL_CDL = main.cdl
 
-APPL_DIRS := $(APPLDIRS) $(SRCDIR)/library
+APPL_DIRS := $(APPLDIRS) $(SRCDIR)/library $(SRCDIR)/$(TINETDIR)/netapp
 APPL_ASMOBJS :=
 ifdef USE_CXX
 	APPL_CXXOBJS := main.o
-	APPL_COBJS := fdtable.o io_stub.o socket_stub.o ffarch.o fftime.o tlsf.o diskio.o ff.o sdfs.o ccsbcs.o base64.o http-strings.o http_parser.o httpd.o httpd-fs.o sha1.o websocket.o websocket_fbs.o ntshell.o text_editor.o text_history.o usrcmd.o vtrecv.o vtsend.o ntlibc.o ntstdio.o ntopt.o syscall.o mbedcall.o
+	APPL_COBJS := fdtable.o stdio_stub.o pipe_stub.o io_stub.o socket_stub.o tlsf.o ffarch.o diskio.o ff.o sdfs.o ccsbcs.o base64.o http-strings.o http_parser.o httpd.o httpd-fs.o sha1.o websocket.o websocket_fbs.o ntshell.o text_editor.o text_history.o usrcmd.o vtrecv.o vtsend.o ntlibc.o ntstdio.o ntopt.o syscall.o mbedcall.o ping.o ping6.o resolver.o dhcp4_cli.o netapp_subr.o ntp_cli.o net_misc.o netcmd.o
 else
-	APPL_COBJS := main.o fdtable.o io_stub.o socket_stub.o ffarch.o fftime.o tlsf.o diskio.o ff.o sdfs.o ccsbcs.o base64.o http-strings.o http_parser.o httpd.o httpd-fs.o sha1.o websocket.o websocket_fbs.o ntshell.o text_editor.o text_history.o usrcmd.o vtrecv.o vtsend.o ntlibc.o ntstdio.o ntopt.o syscall.o mbedcall.o
+	APPL_COBJS := main.o fdtable.o stdio_stub.o pipe_stub.o io_stub.o socket_stub.o tlsf.o ffarch.o diskio.o ff.o sdfs.o ccsbcs.o base64.o http-strings.o http_parser.o httpd.o httpd-fs.o sha1.o websocket.o websocket_fbs.o ntshell.o text_editor.o text_history.o usrcmd.o vtrecv.o vtsend.o ntlibc.o ntstdio.o ntopt.o syscall.o mbedcall.o ping.o ping6.o resolver.o dhcp4_cli.o netapp_subr.o ntp_cli.o net_misc.o netcmd.o
 endif
 APPL_COBJS := $(APPL_COBJS) log_output.o vasyslog.o t_perror.o strerror.o mbed_stub.o
@@ -263,12 +263,4 @@
 #  ã·ã¹ãã ãµã¼ãã¹ã«é¢ããå®ç¾©
 #
-ifdef TCINSTALL
-GCC_PATH = $(TCINSTALL)
-else
-GCC_PATH = $(shell which $(CC))/../../
-endif
-MALLOC_LIB = "${GCC_PATH}arm-none-eabi/lib/thumb/v7-ar/fpv3/hard/libc.a"
-MALLOC_OBJS = lib_a-reent.o lib_a-impure.o lib_a-malloc.o lib_a-mallocr.o lib_a-calloc.o lib_a-callocr.o lib_a-realloc.o lib_a-reallocr.o lib_a-sbrkr.o lib_a-freer.o
-
 SYSSVC_DIRS := $(TECSGENDIR) $(SRCDIR)/tecs_kernel \
 				$(SYSSVC_DIRS) $(SRCDIR)/syssvc
@@ -398,5 +390,4 @@
 CFG_COBJS      := $(addprefix $(OBJDIR)/, $(CFG_COBJS))
 CFG_DMY        := $(addprefix $(OBJDIR)/, $(CFG_DMY))
-MALLOC_OBJS    := $(addprefix $(OBJDIR)/, $(MALLOC_OBJS))
 
 #
@@ -405,5 +396,5 @@
 APPL_OBJS = $(APPL_ASMOBJS) $(APPL_COBJS) $(APPL_CXXOBJS) $(APPL_BINOBJS)
 SYSSVC_OBJS = $(SYSSVC_ASMOBJS) $(SYSSVC_COBJS) $(HIDDEN_OBJS)
-KERNEL_LIB_OBJS = $(KERNEL_ASMOBJS) $(KERNEL_COBJS) $(KERNEL_LCOBJS) $(MALLOC_OBJS)
+KERNEL_LIB_OBJS = $(KERNEL_ASMOBJS) $(KERNEL_COBJS) $(KERNEL_LCOBJS)
 CFG_OBJS = $(CFG_ASMOBJS) $(CFG_COBJS)
 ALL_OBJS = $(START_OBJS) $(APPL_OBJS) $(SYSSVC_OBJS) $(CFG_OBJS) \
@@ -573,5 +564,4 @@
 	rm -f libsyssvc.a
 endif
-	rm -f $(MALLOC_OBJS)
 
 .PHONY: cleankernel
@@ -701,8 +691,4 @@
 	$(OBJCOPY) -B arm -I binary -O elf32-littlearm --rename-section .data=.rodata $< $(OBJDIR)/$*.o
 
-$(MALLOC_OBJS): $(OBJDIR)/%.o:
-	$(AR) x $(MALLOC_LIB) $(notdir $@)
-	mv $(notdir $@) $@
-
 #
 #  ããã©ã«ãã³ã³ãã¤ã«ã«ã¼ã«ãä¸æ¸ã
Index: /EcnlProtoTool/trunk/ntshell/fatfs/diskio.h
===================================================================
--- /EcnlProtoTool/trunk/ntshell/fatfs/diskio.h	(revision 440)
+++ /EcnlProtoTool/trunk/ntshell/fatfs/diskio.h	(revision 441)
@@ -43,5 +43,5 @@
 void disk_timerproc(void);
 
-#define SZ_RAMDISK	1792	/* Size of RAM disk [kB] */
+#define SZ_RAMDISK	1536	/* Size of RAM disk [kB] */
 #define SS_RAMDISK	512		/* Sector size of RAM disk [byte] */
 
Index: /EcnlProtoTool/trunk/ntshell/fatfs/ffarch.c
===================================================================
--- /EcnlProtoTool/trunk/ntshell/fatfs/ffarch.c	(revision 440)
+++ /EcnlProtoTool/trunk/ntshell/fatfs/ffarch.c	(revision 441)
@@ -42,24 +42,79 @@
 #include <kernel.h>
 #include <stdlib.h>
-//#include <string.h>
+#include <string.h>
 #include "t_stdlib.h"
 #include "syssvc/serial.h"
 #include "syssvc/syslog.h"
+#include "target_syssvc.h"
 #include "kernel_cfg.h"
 #include "diskio.h"
 #include "sdfs.h"
 #include "ff.h"
-#include "tlsf.h"
-#include "util/ntstdio.h"
+#include <stdio.h>
+#include "hal/rtc_api.h"
+#include "ffarch.h"
 
 #define SD_CARD_LOG_LEVEL LOG_INFO
 
-#define SIO_PORTID 1
-extern ntstdio_t ntstdio;
-
-static tlsf_t sys_tlsf;
-static pool_t sys_pool;
-
-uint8_t shell_heap[64 * 1024];
+enum ffarch_state_t {
+	FFS_IDLE,
+	FFS_RETRY_WAIT,
+};
+
+enum ffarch_state_t ffarch_state;
+volatile int ffarch_timer;
+int ffarch_retry_count;
+uint8_t sdfs_new_status, sdfs_prev_status;
+
+static void ffarch_initialize();
+
+/*
+ * FatFSタスク
+ */
+void ffarch_task(intptr_t exinf)
+{
+	ER ret, ret2;
+	SYSTIM prev, now;
+	int timer;
+
+	ffarch_initialize();
+
+	ret2 = get_tim(&now);
+	if (ret2 != E_OK){
+		syslog(LOG_NOTICE, "[ffarch] get_tim error: %s",
+			itron_strerror(ret2));
+		return;
+	}
+
+	for(;;){
+		prev = now;
+
+		/* タイマー取得 */
+		timer = ffarch_get_timer();
+
+		/* 待ち */
+		ret = tslp_tsk(timer);
+		if ((ret != E_OK) && (ret != E_TMOUT)) {
+			syslog(LOG_NOTICE, "[ffarch] tslp_tsk error: %s %d",
+				itron_strerror(ret), timer);
+			break;
+		}
+
+		ret2 = get_tim(&now);
+		if (ret2 != E_OK) {
+			syslog(LOG_NOTICE, "[ffarch] get_tim error: %s",
+				itron_strerror(ret2));
+			break;
+		}
+
+		/* 時間経過 */
+		int elapse = now - prev;
+		ffarch_progress(elapse);
+
+		/* タイムアウト処理 */
+		ffarch_timeout();
+	}
+}
+
 FATFS RomDisk;
 
@@ -75,14 +130,9 @@
 SD Sd;
 
-void sys_init(void);
 bool_t romdisk_init();
 bool_t SD_begin();
 
-int mruby_arduino_init()
-{
-	int result = -1;
-
-	sys_init();
-
+void ffarch_init(void)
+{
 	/* SD_CD */
 	gpio_init_in(&ins, P7_8);
@@ -91,65 +141,25 @@
 	sdfs_init(&sdfs, P8_5, P8_6, P8_3, P8_4, "sd");
 
-	result = SD_begin() ? 0 : -1;
-	if (result == 0) {
-		ntstdio_printf(&ntstdio, "SD card (1:) OK!\n");
+	ffarch_state = FFS_IDLE;
+	ffarch_timer = 0;
+	ffarch_retry_count = 3;
+	sdfs_new_status = 0;
+	sdfs_prev_status = STA_NODISK;
+
+	ffarch_timeout();
+
+	act_tsk(FFARCH_TASK);
+
+	if (romdisk_init()) {
+		syslog(LOG_NOTICE, "ROM disk (0:) OK!");
 	}
 	else {
-		ntstdio_printf(&ntstdio, "SD card (1:) NG!\n");
-	}
+		syslog(LOG_NOTICE, "ROM disk (0:) NG!");
+	}
+}
+
+void ffarch_initialize()
+{
 	sta_cyc(SDFS_CYC);
-
-	if (romdisk_init())
-		result = 0;
-
-	if (result == 0) {
-		ntstdio_printf(&ntstdio, "ROM disk (0:) OK!\n");
-	}
-	else {
-		ntstdio_printf(&ntstdio, "ROM disk (0:) NG!\n");
-	}
-
-	/* uploadディレクトリを作成しておく */
-	f_mkdir("1:/upload");
-
-	serial_ctl_por(SIO_PORTID, IOCTL_FCSND | IOCTL_FCRCV);
-
-	return result;
-}
-
-void sys_init(void)
-{
-	sys_tlsf = tlsf_create(&shell_heap);
-	if (sys_tlsf == NULL)
-		return;
-
-	sys_pool = tlsf_add_pool(sys_tlsf, ((uint8_t *)&shell_heap) + tlsf_size(), sizeof(shell_heap) - tlsf_size());
-}
-
-void sys_fini(void)
-{
-	tlsf_destroy(sys_tlsf);
-}
-
-void *sys_malloc(size_t size)
-{
-	return tlsf_malloc(sys_tlsf, size);
-}
-
-void *sys_calloc(size_t size, size_t count)
-{
-	void *result = tlsf_malloc(sys_tlsf, count * size);
-	memset(result, 0, count * size);
-	return result;
-}
-
-void *sys_realloc(void *ptr, size_t size)
-{
-	return tlsf_realloc(sys_tlsf, ptr, size);
-}
-
-void sys_free(void *ptr)
-{
-	tlsf_free(sys_tlsf, ptr);
 }
 
@@ -219,5 +229,5 @@
 		return ramdisk_get_status();
 	case 1:
-		return sdfs_status(&sdfs);
+		return sdfs._is_initialized;
 	}
 	return STA_NOINIT;
@@ -246,4 +256,6 @@
 }
 
+DRESULT sdfs_ioctl(BYTE ctrl, void *buff);
+
 DRESULT disk_ioctl(BYTE pdrv, BYTE cmd, void *buff)
 {
@@ -252,31 +264,166 @@
 		return RES_PARERR; /* ramdisk_ioctl(cmd, buff); */
 	case 1:
-		switch(cmd) {
-		case CTRL_SYNC:
-			return sdfs_sync(&sdfs);
-		case GET_SECTOR_COUNT:
-			return sdfs_sectors(&sdfs);
-		case GET_BLOCK_SIZE:
-			*((DWORD*)buff) = 1; // default when not known
-			return RES_OK;
-		}
+		return sdfs_ioctl(cmd, buff);
 	}
 	return RES_PARERR;
 }
 
+DRESULT sdfs_ioctl(BYTE ctrl, void *buff)
+{
+	DRESULT res;
+	uint32_t *dp = (uint32_t *)buff;
+	uint8_t *ptr = (uint8_t *)buff;
+
+	if (sdfs._is_initialized & STA_NOINIT)
+		return RES_NOTRDY;
+
+	res = RES_ERROR;
+
+	switch (ctrl) {
+	case CTRL_SYNC:
+		if (sdfs_sync(&sdfs) == 0) {
+			res = RES_OK;
+		}
+		break;
+	case GET_SECTOR_SIZE:
+		*(WORD*)buff = 512;
+		res = RES_OK;
+		break;
+	case GET_SECTOR_COUNT:
+		*(DWORD*)buff = sdfs._capacity / 512;
+		res = RES_OK;
+		break;
+	case GET_BLOCK_SIZE:
+		*(DWORD*)buff = sdfs._block_len;
+		res = RES_OK;
+		break;
+	case CTRL_TRIM:
+		res = sdfs_trim(&sdfs, dp[0], dp[1]);
+		break;
+	case MMC_GET_TYPE:
+		*ptr = sdfs._card_type;
+		res = RES_OK;
+		break;
+	case MMC_GET_CSD:
+		memcpy(ptr, sdfs._csd, sizeof(sdfs._csd));
+		res = RES_OK;
+		break;
+	case MMC_GET_CID:
+		memcpy(ptr, sdfs._cid, sizeof(sdfs._cid));
+		res = RES_OK;
+		break;
+	case MMC_GET_OCR:
+		if (sdfs_get_ocr(&sdfs, buff) == 0) {
+			res = RES_OK;
+		}
+		break;
+	case MMC_GET_SDSTAT:
+		if (sdfs_get_sdstat(&sdfs, buff) == 0) {
+			res = RES_OK;
+		}
+		break;
+	default:
+		res = RES_PARERR;
+	}
+
+	return res;
+}
+
 void sdfs_cychdr(intptr_t exinf)
 {
-	BYTE s;
-
-	s = sdfs._is_initialized;
-	if (WP())		/* Write protected */
+	BYTE s = 0;
+             
+	/* Write protected */
+	if (WP())
 		s |= STA_PROTECT;
-	else		/* Write enabled */
+	else
 		s &= ~STA_PROTECT;
-	if (gpio_read(&ins))	/* Card is in socket */
+
+	/* Card is in socket */
+	if (gpio_read(&ins))
+		s |= (STA_NODISK | STA_NOINIT);
+	else
 		s &= ~STA_NODISK;
-	else		/* Socket empty */
-		s |= (STA_NODISK | STA_NOINIT);
-	sdfs._is_initialized = s;
+
+	sdfs_new_status = s;
+
+	if ((sdfs_prev_status != sdfs_new_status) && (ffarch_state == FFS_IDLE)) {
+		ffarch_timer = 0;
+		wup_tsk(FFARCH_TASK);
+	}
+}
+
+int ffarch_get_timer(void)
+{
+	return ffarch_timer;
+}
+
+void ffarch_progress(int elapse)
+{
+	if (ffarch_timer != TMO_FEVR) {
+		ffarch_timer -= elapse;
+		if (ffarch_timer < 0) {
+			ffarch_timer = 0;
+		}
+	}
+}
+
+void ffarch_timeout(void)
+{
+	if (ffarch_timer != 0)
+		return;
+
+	switch (ffarch_state) {
+	case FFS_RETRY_WAIT:
+		if (ffarch_retry_count == 0) {
+			syslog(SD_CARD_LOG_LEVEL, "SD card (1:) initialize tired...");
+
+			ffarch_state = FFS_IDLE;
+			ffarch_timer = TMO_FEVR;
+			ffarch_retry_count = 3;
+			break;
+		}
+		ffarch_retry_count--;
+		//goto case FFS_IDLE;
+	case FFS_IDLE:
+ 		/* SDカードが入れられた場合 */
+ 		if ((sdfs._is_initialized & STA_NOINIT)
+ 			|| (((sdfs_prev_status & STA_NODISK) != 0) && ((sdfs_new_status & STA_NODISK) == 0))) {
+			syslog(SD_CARD_LOG_LEVEL, "SD card initializing ...");
+
+			if (SD_begin()) {
+				syslog(SD_CARD_LOG_LEVEL, "SD card (1:) OK!");
+
+				/* uploadディレクトリを作成しておく */
+				f_mkdir("1:/upload");
+
+				ffarch_state = FFS_IDLE;
+				ffarch_timer = TMO_FEVR;
+				ffarch_retry_count = 3;
+			}
+			else {
+				syslog(SD_CARD_LOG_LEVEL, "SD card (1:) NG!");
+				ffarch_state = FFS_RETRY_WAIT;
+				ffarch_timer = 1000 * 1000;
+			}
+		}
+		/* SDカードが抜かれた場合 */
+		else if (((sdfs_prev_status & STA_NODISK) == 0) && ((sdfs_new_status & STA_NODISK) != 0)) {
+			syslog(SD_CARD_LOG_LEVEL, "SD card unmount");
+
+			f_mount(&Sd.FatFs, "1:", 0);
+			ffarch_state = FFS_IDLE;
+			ffarch_timer = TMO_FEVR;
+			ffarch_retry_count = 3;
+		}
+		if (((sdfs_prev_status ^ sdfs_new_status) & STA_PROTECT) != 0) {
+			if ((sdfs_new_status & STA_PROTECT) != 0)
+				sdfs._is_initialized |= STA_PROTECT;
+			else
+				sdfs._is_initialized &= ~STA_PROTECT;
+		}
+		sdfs_prev_status = sdfs_new_status;
+		break;
+	}
 }
 
@@ -314,10 +461,10 @@
 void* ff_memalloc (UINT msize)
 {
-	return sys_malloc(msize);
+	return malloc(msize);
 }
 
 void ff_memfree (void* mblock)
 {
-	sys_free(mblock);
+	free(mblock);
 }
 
Index: /EcnlProtoTool/trunk/ntshell/fatfs/ffarch.cfg
===================================================================
--- /EcnlProtoTool/trunk/ntshell/fatfs/ffarch.cfg	(revision 440)
+++ /EcnlProtoTool/trunk/ntshell/fatfs/ffarch.cfg	(revision 441)
@@ -38,6 +38,7 @@
 #include "ffarch.h"
 
+CRE_TSK(FFARCH_TASK, { TA_NULL, 0, ffarch_task, FFARCH_PRIORITY, FFARCH_STACK_SIZE, NULL });
 CRE_CYC(SDFS_CYC, { TA_NULL, { TNFY_HANDLER, 0, sdfs_cychdr }, 1000000, 0 });
 
-CRE_SEM(SEM_MALLOC, { TA_TPRI, 1, 1 });
+CRE_SEM(SEM_FILESYSTEM, { TA_TPRI, 1, 1 });
 
Index: /EcnlProtoTool/trunk/ntshell/fatfs/ffarch.h
===================================================================
--- /EcnlProtoTool/trunk/ntshell/fatfs/ffarch.h	(revision 440)
+++ /EcnlProtoTool/trunk/ntshell/fatfs/ffarch.h	(revision 441)
@@ -38,5 +38,13 @@
 #define _FFARCH_H_
 
-int mruby_arduino_init();
+#define FFARCH_PRIORITY			5
+#define FFARCH_STACK_SIZE		512
+
+void ffarch_init(void);
+void ffarch_task(intptr_t exinf);
+int ffarch_get_timer(void);
+void ffarch_progress(int elapse);
+void ffarch_timeout(void);
+
 void sdfs_cychdr(intptr_t exinf);
 
Index: /EcnlProtoTool/trunk/ntshell/ntshell/core/ntlibc.h
===================================================================
--- /EcnlProtoTool/trunk/ntshell/ntshell/core/ntlibc.h	(revision 440)
+++ /EcnlProtoTool/trunk/ntshell/ntshell/core/ntlibc.h	(revision 441)
@@ -52,5 +52,5 @@
 int ntlibc_tolower(int c);
 int ntlibc_atoi(const char *nptr);
-unsigned long ntlibc_strtoul(const char *__restrict nptr, char **__restrict endptr, int base);
+unsigned long ntlibc_strtoul(const char *restrict nptr, char **restrict endptr, int base);
 char *ntlibc_strchr(const char *s, int c);
 char *ntlibc_utoa(unsigned int value, char *s, int radix);
Index: /EcnlProtoTool/trunk/ntshell/ntshell/usrcmd.c
===================================================================
--- /EcnlProtoTool/trunk/ntshell/ntshell/usrcmd.c	(revision 440)
+++ /EcnlProtoTool/trunk/ntshell/ntshell/usrcmd.c	(revision 441)
@@ -33,12 +33,11 @@
 #include "shellif.h"
 #include <kernel.h>
-//#include <string.h>
 #include <t_syslog.h>
 #include <t_stdlib.h>
 #include <sil.h>
 #include "syssvc/syslog.h"
+#include "target_syssvc.h"
 #include "kernel_cfg.h"
 #include "main.h"
-#include "rza1.h"
 #include "ffarch.h"
 #include "ff.h"
@@ -48,5 +47,5 @@
 #include "util/ntstdio.h"
 
-extern ntstdio_t ntstdio;
+extern ntstdio_t *ntstdio;
 extern int ntshell_exit;
 
@@ -147,20 +146,4 @@
 }
 
-int shell_kill(int pid, int sig)
-{
-	asm("bkpt #0");
-	return -1;
-}
-
-int shell_gettimeofday(struct timeval *tv, void *tzvp)
-{
-	SYSTIM time;
-	if (!tv) return 0;
-	get_tim(&time);
-	tv->tv_sec = time / 1000000;
-	tv->tv_usec = time - (tv->tv_sec * 1000000);
-	return 0;
-}
-
 void put_rc(const char *func, FRESULT rc)
 {
@@ -175,5 +158,5 @@
 		while (*p++);
 	}
-	ntstdio_printf(&ntstdio, "%s() =>%u FR_%s\n", func, (UINT)rc, p);
+	ntstdio_printf(ntstdio, "%s() =>%u FR_%s\n", func, (UINT)rc, p);
 }
 
@@ -187,5 +170,5 @@
 		while (*p++);
 	}
-	ntstdio_printf(&ntstdio, "%s() =>%u %s\n", func, (UINT)rc, p);
+	ntstdio_printf(ntstdio, "%s() =>%u %s\n", func, (UINT)rc, p);
 }
 
@@ -210,5 +193,5 @@
 	for (; s[i] == '/'; i--) if (!i) return (s == _s) ? "/" : _s;
 	for (; s[i] != '/'; i--) if (!i) return (s == _s) ? "." : _s;
-	for (; s[i] == '/'; i--) if (!i) if (s == _s) return "/"; else break;
+	for (; s[i] == '/'; i--) if (!i) { if (s == _s) return "/"; else break; }
 	s[i + 1] = 0;
 	return _s;
@@ -237,5 +220,5 @@
 
 	ntlibc_strlcat(path, "\n", sizeof(path));
-	ntstdio_printf(&ntstdio, path);
+	ntstdio_printf(ntstdio, path);
 
 	return 0;
@@ -260,5 +243,5 @@
 
 	if (list_option & LS_LONG) {
-		ntstdio_printf(&ntstdio, "%c%c%c%c%c %04d/%02d/%02d %02d:%02d:%02d ",
+		ntstdio_printf(ntstdio, "%c%c%c%c%c %04d/%02d/%02d %02d:%02d:%02d ",
 			(fno->fattrib & AM_DIR) ? 'd' : '-',
 			(fno->fattrib & AM_RDO) ? 'r' : '-',
@@ -274,16 +257,16 @@
 
 		if (fno->fattrib & AM_DIR) {                    /* It is a directory */
-			ntstdio_printf(&ntstdio, "%10S ", " ");
+			ntstdio_printf(ntstdio, "%10s ", " ");
 		}
 		else {
-			ntstdio_printf(&ntstdio, "%10d ", fno->fsize);
+			ntstdio_printf(ntstdio, "%10lu ", fno->fsize);
 		}
 	}
 
 	if (fno->fattrib & AM_DIR) {                    /* It is a directory */
-		ntstdio_printf(&ntstdio, "\x1B[32m%s\x1B[0m\n", fn);
+		ntstdio_printf(ntstdio, "\x1B[32m%s\x1B[0m\n", fn);
 	}
 	else {
-		ntstdio_printf(&ntstdio, "%s\n", fn);
+		ntstdio_printf(ntstdio, "%s\n", fn);
 	}
 }
@@ -304,5 +287,5 @@
 	path_backup = ff_memalloc(LFN_BUF_SIZE);
 	if (path_backup == NULL) {
-		ntstdio_printf(&ntstdio, "ff_memalloc err.\n");
+		ntstdio_printf(ntstdio, "ff_memalloc err.\n");
 		return;
 	}
@@ -312,5 +295,5 @@
 	lfn = ff_memalloc(LFN_BUF_SIZE);
 	if (lfn == NULL) {
-		ntstdio_printf(&ntstdio, "ff_memalloc err.\n");
+		ntstdio_printf(ntstdio, "ff_memalloc err.\n");
 		ff_memfree(path_backup);
 		return;
@@ -340,23 +323,23 @@
 			}
 
-			if ((res = f_chdrive(path_p)) != RES_OK) {
+			if ((res = f_chdrive(path_p)) != FR_OK) {
 				put_rc("f_chdrive", res);
 			}
 
-			if ((res = f_chdir(path_p)) != RES_OK) {
+			if ((res = f_chdir(path_p)) != FR_OK) {
 				put_rc("f_chdir", res);
 			}
 
-			ntstdio_printf(&ntstdio, "\n%s/%s:\n", path_p, fn);
+			ntstdio_printf(ntstdio, "\n%s/%s:\n", path_p, fn);
 
 			print_ls(fn, NULL, list_option);
 
-			ntstdio_printf(&ntstdio, "\n");
-
-			if ((res = f_chdrive(path_backup)) != RES_OK) {
+			ntstdio_printf(ntstdio, "\n");
+
+			if ((res = f_chdrive(path_backup)) != FR_OK) {
 				put_rc("f_chdrive", res);
 			}
 
-			if ((res = f_chdir(path_backup)) != RES_OK) {
+			if ((res = f_chdir(path_backup)) != FR_OK) {
 				put_rc("f_chdir", res);
 			}
@@ -449,5 +432,5 @@
 	lfn = ff_memalloc(LFN_BUF_SIZE);
 	if (lfn == NULL) {
-		ntstdio_printf(&ntstdio, "alloc err.\n");
+		ntstdio_printf(ntstdio, "alloc err.\n");
 		goto cp_end;
 	}
@@ -459,5 +442,5 @@
 	local_buff = ff_memalloc(64);
 	if (local_buff == NULL) {
-		ntstdio_printf(&ntstdio, "alloc err.\n");
+		ntstdio_printf(ntstdio, "alloc err.\n");
 		goto cp_end;
 	}
@@ -469,7 +452,7 @@
 	if (res != FR_OK) {
 		if (res == FR_NO_FILE)
-			ntstdio_printf(&ntstdio, "src no file.\n", res);
+			ntstdio_printf(ntstdio, "src no file.\n");
 		else
-			ntstdio_printf(&ntstdio, "src stat err(%d).\n", res);
+			ntstdio_printf(ntstdio, "src stat err(%d).\n", res);
 		goto cp_end;
 	}
@@ -480,5 +463,5 @@
 		res = f_open(&src_fp, src_str_p, (FA_OPEN_EXISTING | FA_READ));
 		if (res != FR_OK) {
-			ntstdio_printf(&ntstdio, "src open err(%d).\n", res);
+			ntstdio_printf(ntstdio, "src open err(%d).\n", res);
 			goto cp_end;
 		}
@@ -495,5 +478,5 @@
 				dst_mod_str_p = ff_memalloc(LFN_BUF_SIZE);
 				if (dst_mod_str_p == NULL) {
-					ntstdio_printf(&ntstdio, "alloc err.\n");
+					ntstdio_printf(ntstdio, "alloc err.\n");
 					goto cp_end;
 				}
@@ -502,10 +485,10 @@
 			}
 			else {
-				ntstdio_printf(&ntstdio, "dst file exists.\n");
+				ntstdio_printf(ntstdio, "dst file exists.\n");
 				goto cp_end_1;
 			}
 		}
 		else {
-			ntstdio_printf(&ntstdio, "src stat err(%d).\n", res);
+			ntstdio_printf(ntstdio, "src stat err(%d).\n", res);
 			goto cp_end_1;
 		}
@@ -513,5 +496,5 @@
 	res = f_open(&dst_fp, dst_str_p, (FA_CREATE_NEW | FA_WRITE));
 	if (res != FR_OK) {
-		ntstdio_printf(&ntstdio, "dst open err(%d).\n", res);
+		ntstdio_printf(ntstdio, "dst open err(%d).\n", res);
 		goto cp_end_1;
 	}
@@ -524,5 +507,5 @@
 		res = f_read(&src_fp, local_buff, sizeof(local_buff), &read_size);
 		if (res != FR_OK) {
-			ntstdio_printf(&ntstdio, "src read err(%d).\n", res);
+			ntstdio_printf(ntstdio, "src read err(%d).\n", res);
 			goto cp_end_2;
 		}
@@ -531,9 +514,9 @@
 		res = f_write(&dst_fp, local_buff, read_size, &write_size);
 		if (res != FR_OK) {
-			ntstdio_printf(&ntstdio, "dst write err(%d).\n", res);
+			ntstdio_printf(ntstdio, "dst write err(%d).\n", res);
 			goto cp_end_2;
 		}
 		if (read_size != write_size) {
-			ntstdio_printf(&ntstdio, "dst write err(disk full).\n", res);
+			ntstdio_printf(ntstdio, "dst write err(disk full).\n");
 			goto cp_end_2;
 		}
@@ -594,6 +577,4 @@
 }
 
-extern WCHAR Utf8_to_Utf16(const char *, int *); /* in ff.c */
-extern void Utf16_to_Utf8(unsigned char *, int *, UINT); /* in ff.c */
 #define HEXDUMP_EXTRA_FOR_UTF8 3 /* need extra buffer size */
 #define CCOLOR_RESET	0
@@ -626,10 +607,10 @@
 		switch (op) {
 		case 'h': /* help */
-			ntstdio_printf(&ntstdio, " hexdump [OPTION] file\n");
-			ntstdio_printf(&ntstdio, "  -h : help\n");
-			ntstdio_printf(&ntstdio, "  -d : print all byte with convert and color [in character area] (default)\n");
-			ntstdio_printf(&ntstdio, "  -u : try print UTF-8 code [in character area]\n");
-			ntstdio_printf(&ntstdio, "  -oOFFSET : print start offset address from top\n");
-			ntstdio_printf(&ntstdio, "  -sSIZE   : print size\n");
+			ntstdio_printf(ntstdio, " hexdump [OPTION] file\n");
+			ntstdio_printf(ntstdio, "  -h : help\n");
+			ntstdio_printf(ntstdio, "  -d : print all byte with convert and color [in character area] (default)\n");
+			ntstdio_printf(ntstdio, "  -u : try print UTF-8 code [in character area]\n");
+			ntstdio_printf(ntstdio, "  -oOFFSET : print start offset address from top\n");
+			ntstdio_printf(ntstdio, "  -sSIZE   : print size\n");
 			break;
 		case 'd': /* print one byte character [in character area] (default) */
@@ -662,5 +643,5 @@
 	/* position adjusting */
 	if (op_offset >= fsrc.fsize) {
-		ntstdio_printf(&ntstdio, "error : input offset is bigger than file size(0x%X).\n", fsrc.fsize);
+		ntstdio_printf(ntstdio, "error : input offset is bigger than file size(0x%lX).\n", fsrc.fsize);
 		return 0;
 	}
@@ -689,5 +670,5 @@
 		if (br > 16) br = 16;
 
-		char *apos = ascii;
+		unsigned char *apos = ascii;
 		int arst = sizeof(ascii);
 		for (int j = 0; j < br; j++) {
@@ -784,5 +765,5 @@
 		rst -= len;
 
-		ntstdio_puts(&ntstdio, line);
+		ntstdio_puts(ntstdio, line);
 	}
 
@@ -799,5 +780,5 @@
 	ret = shell_clock_gettime(CLOCK_REALTIME, &tp);
 	if (ret != 0) {
-		ntstdio_printf(&ntstdio, "clock_gettime error %d", ret);
+		ntstdio_printf(ntstdio, "clock_gettime error %d", ret);
 		return 0;
 	}
@@ -805,5 +786,5 @@
 	memset(buf, 0, sizeof(buf));
 	if (ctime_r(&tp.tv_sec, buf) == NULL) {
-		ntstdio_printf(&ntstdio, "ctime_r error");
+		ntstdio_printf(ntstdio, "ctime_r error");
 		return 0;
 	}
@@ -813,5 +794,5 @@
 	buf[ret - 1] = '\0';
 
-	ntstdio_printf(&ntstdio, "%s .%09ld\n", buf, tp.tv_nsec);
+	ntstdio_printf(ntstdio, "%s .%09ld\n", buf, tp.tv_nsec);
 	return 0;
 }
@@ -820,10 +801,10 @@
 {
 	if (argc != 2) {
-		ntstdio_printf(&ntstdio, "info sys\n");
-		ntstdio_printf(&ntstdio, "info ver\n");
+		ntstdio_printf(ntstdio, "info sys\n");
+		ntstdio_printf(ntstdio, "info ver\n");
 		return 0;
 	}
 	if (ntlibc_strcmp(argv[1], "sys") == 0) {
-		ntstdio_printf(&ntstdio, "GR-PEACH Monitor\n");
+		ntstdio_printf(ntstdio, TARGET_NAME" Monitor\n");
 		return 0;
 	}
@@ -831,8 +812,8 @@
 		int mj, mn, bd;
 		ntshell_version(&mj, &mn, &bd);
-		ntstdio_printf(&ntstdio, "Version %d.%d.%d\n", mj, mn, bd);
-		return 0;
-	}
-	ntstdio_printf(&ntstdio, "Unknown sub command found\n");
+		ntstdio_printf(ntstdio, "Version %d.%d.%d\n", mj, mn, bd);
+		return 0;
+	}
+	ntstdio_printf(ntstdio, "Unknown sub command found\n");
 	return -1;
 }
Index: /EcnlProtoTool/trunk/ntshell/ntshell/usrcmd.h
===================================================================
--- /EcnlProtoTool/trunk/ntshell/ntshell/usrcmd.h	(revision 440)
+++ /EcnlProtoTool/trunk/ntshell/ntshell/usrcmd.h	(revision 441)
@@ -56,9 +56,4 @@
 int usrcmd_exit(int argc, char **argv);
 
-void shell_abort();
-void shell_exit(int exitcd);
-int shell_kill(int pid, int sig);
-int shell_gettimeofday(struct timeval * tp, void * tzvp);
-
 #endif
 
